UINT8 main(void)
{
    
	UINT8 stat, body, hue, err;	// error checking

	stat = decode_jpeg_header();

	// decode header first
	Write_to_JPEG_FIFO(size);	// this routine will extract JPEG data and write to JPEG FIFO address define by reg 414h
								// however as we are only decoding header, need only to write about 1024 - 2048 bytes

	// get the parameters of the file and do the neccessary resizing
	stat = get_jpeg_file_parameters();
	if ( stat == 1 )
	{
		error = 0x41;	// cannot get the file parameters
		goto err1;
	}
			
	ssd192X_lcd_blank_enable(1);
	// decode body 
	body = decode_jpeg_body();	// set the JPEG parameter, get ready to show it
	Write_to_JPEG_FIFO(size);	// write the whole JPEG file to the FIFO	

	Off_jpeg();

	decoding = SSD_REGRB(0x385);	// check is the JPEG being decoded or not
	if(decoding != 0x22 )
	{
		err = 0x06;			// 6 = file is not decoded
		goto err1;
	}
		
	if ( stat == 9 )
	{
		// 	picture not the usual 320 x 240, thus need to manipulate a bit 
		enable_float_win();
		SSD_REGWL(REG_MAIN_WIN_DISP_START_ADDR0, 0x40000>>2);	// this will make the background black
	}
		
	else
	{
		hue = SSD_REGRB(REG_DV_OFORMAT);	// Reg 1A4
		hue = hue & 0xBF;					// Bit 6 set main window to YUV
		SSD_REGWB(REG_DV_OFORMAT, hue);

		SSD_REGWL(REG_MAIN_WIN_DISP_START_ADDR0, 0x1A000>>2);
	}

err1:
	if (err == 0)
	{
		ssd192X_lcd_blank_enable(0);	// show content
	}
	else
	{
		// if error, do something...
	}

	err = 0;
	stat = body = 0;

	return error;
}